"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateV31Spec = exports.generateV30Spec = void 0;
var json_schema_to_openapi_schema_1 = __importDefault(require("@openapi-contrib/json-schema-to-openapi-schema"));
var utilities_1 = require("payload/utilities");
var upperFirst = function (value) { return value[0].toUpperCase() + value.slice(1); };
var camelize = function (value) { return value.split(/\s+/).map(upperFirst).join(''); };
var collectionName = function (collection) {
    var labels = collection.config.labels;
    if (labels === undefined) {
        return { singular: collection.config.slug, plural: collection.config.slug };
    }
    var label = function (value) {
        if (typeof value === 'string') {
            return value;
        }
        return value['en'];
    };
    return { singular: label(labels.singular), plural: label(labels.plural) };
};
var globalName = function (global) {
    if (global.label === undefined) {
        return global.slug;
    }
    if (typeof global.label === 'string') {
        return global.label;
    }
    return global.label['en'];
};
var componentName = function (type, name, _a) {
    var _b = _a === void 0 ? {} : _a, prefix = _b.prefix, suffix = _b.suffix;
    name = camelize(name);
    if (prefix) {
        name = prefix + name;
    }
    if (suffix) {
        name += suffix;
    }
    if (type === 'responses') {
        name += 'Response';
    }
    if (type === 'requestBodies') {
        name += 'RequestBody';
    }
    return name;
};
var composeRef = function (type, name, options) { return ({
    $ref: "#/components/".concat(type, "/").concat(componentName(type, name, options)),
}); };
var adjustRefTargets = function (req, subject) {
    var search = new RegExp('^#/definitions/(.*)');
    for (var _i = 0, _a = Object.entries(subject); _i < _a.length; _i++) {
        var _b = _a[_i], key = _b[0], value = _b[1];
        if (key === '$ref' && typeof value === 'string') {
            subject[key] = value.replace(search, function (_match, name) {
                if (req.payload.collections[name] !== undefined) {
                    name = collectionName(req.payload.collections[name]).singular;
                }
                else {
                    var global_1 = req.payload.globals.config.find(function (_a) {
                        var slug = _a.slug;
                        return slug === name;
                    });
                    if (global_1 === undefined) {
                        throw new Error("Unknown reference: ".concat(name));
                    }
                    name = globalName(global_1);
                }
                return "#/components/schemas/".concat(componentName('schemas', name));
            });
        }
        if (typeof value === 'object' && value !== null && value !== null) {
            adjustRefTargets(req, value);
        }
    }
};
var mapValuesAsync = function (mapper, record) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _b = (_a = Object).fromEntries;
                return [4 /*yield*/, Promise.all(Object.entries(record).map(function (_a) {
                        var key = _a[0], value = _a[1];
                        return __awaiter(void 0, void 0, void 0, function () { var _b; return __generator(this, function (_c) {
                            switch (_c.label) {
                                case 0:
                                    _b = [key];
                                    return [4 /*yield*/, mapper(value)];
                                case 1: return [2 /*return*/, _b.concat([_c.sent()])];
                            }
                        }); });
                    }))];
            case 1: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
        }
    });
}); };
var generateSchemaObject = function (config, collection) {
    var schema = (0, utilities_1.entityToJSONSchema)(config, collection.config);
    return __assign(__assign({}, schema), { title: collectionName(collection).singular });
};
var requestBodySchema = function (fields, schema) {
    var _a;
    return (__assign(__assign({}, schema), { properties: Object.fromEntries(Object.entries((_a = schema.properties) !== null && _a !== void 0 ? _a : {})
            .filter(function (_a) {
            var slug = _a[0];
            return !['id', 'createdAt', 'updatedAt'].includes(slug);
        })
            .map(function (_a) {
            var fieldName = _a[0], schema = _a[1];
            var field = fields.find(function (field) { return field.name === fieldName; });
            if ((field === null || field === void 0 ? void 0 : field.type) === 'relationship') {
                var target = Array.isArray(field.relationTo) ? field.relationTo : [field.relationTo];
                return [fieldName, { type: 'string', description: "ID of the ".concat(target.join('/')) }];
            }
            return [fieldName, schema];
        })) }));
};
var generateRequestBodySchema = function (config, collection) {
    var schema = (0, utilities_1.entityToJSONSchema)(config, collection.config);
    return {
        description: collectionName(collection).singular,
        content: {
            'text/json': {
                schema: requestBodySchema(collection.config.fields, schema),
            },
        },
    };
};
var generateQueryOperationSchemas = function (collection) {
    var _a;
    var singular = collectionName(collection).singular;
    return _a = {},
        _a[componentName('schemas', singular, { suffix: 'QueryOperations' })] = {
            title: "".concat(singular, " query operations"),
            type: 'object',
            properties: Object.fromEntries(collection.config.fields.filter(function (_a) {
                var type = _a.type;
                return ['number', 'text', 'email', 'date', 'radio', 'select'].includes(type);
            }).map(function (field) {
                var _a;
                var comparedValueSchema = (function () {
                    switch (field.type) {
                        case 'number':
                            return { type: 'number' };
                        case 'text':
                            return { type: 'string' };
                        case 'email':
                            return { type: 'string', format: 'email' };
                        case 'date':
                            return { type: 'string', format: 'date-time' };
                        case 'radio':
                        case 'select':
                            return {
                                type: 'string',
                                enum: field.options.map(function (it) {
                                    return typeof it === 'string' ? it : it.value;
                                }),
                            };
                    }
                })();
                var properties = (_a = {},
                    _a['equals'] = comparedValueSchema,
                    _a['not_equals'] = comparedValueSchema,
                    _a['in'] = { type: 'string' },
                    _a['not_in'] = { type: 'string' },
                    _a);
                if (field.type === 'text') {
                    properties['like'] = comparedValueSchema;
                }
                if (field.type === 'text' || field.type === 'email') {
                    properties['contains'] = comparedValueSchema;
                }
                if (field.type === 'number' || field.type === 'date') {
                    properties['greater_than'] = comparedValueSchema;
                    properties['greater_than_equal'] = comparedValueSchema;
                    properties['less_than'] = comparedValueSchema;
                    properties['less_than_equal'] = comparedValueSchema;
                }
                return [
                    field.name,
                    {
                        type: 'object',
                        properties: properties,
                    },
                ];
            })),
        },
        _a[componentName('schemas', singular, { suffix: 'QueryOperationsAnd' })] = {
            title: "".concat(singular, " query conjunction"),
            type: 'object',
            properties: {
                and: {
                    type: 'array',
                    items: {
                        anyOf: [
                            composeRef('schemas', singular, { suffix: 'QueryOperations' }),
                            composeRef('schemas', singular, { suffix: 'QueryOperationsAnd' }),
                            composeRef('schemas', singular, { suffix: 'QueryOperationsOr' }),
                        ],
                    },
                },
            },
            required: ['and'],
        },
        _a[componentName('schemas', singular, { suffix: 'QueryOperationsOr' })] = {
            title: "".concat(singular, " query disjunction"),
            type: 'object',
            properties: {
                or: {
                    type: 'array',
                    items: {
                        anyOf: [
                            composeRef('schemas', singular, { suffix: 'QueryOperations' }),
                            composeRef('schemas', singular, { suffix: 'QueryOperationsAnd' }),
                            composeRef('schemas', singular, { suffix: 'QueryOperationsOr' }),
                        ],
                    },
                },
            },
            required: ['or'],
        },
        _a;
};
var generateCollectionResponses = function (collection) {
    var _a;
    var _b = collectionName(collection), singular = _b.singular, plural = _b.plural;
    return _a = {},
        _a[componentName('responses', singular)] = {
            description: "".concat(singular, " object"),
            content: {
                'text/json': {
                    schema: composeRef('schemas', singular),
                },
            },
        },
        _a[componentName('responses', singular, { prefix: 'New' })] = {
            description: "".concat(singular, " object"),
            content: {
                'text/json': {
                    schema: {
                        type: 'object',
                        properties: {
                            message: { type: 'string' },
                            doc: {
                                allOf: [
                                    composeRef('schemas', singular),
                                    {
                                        type: 'object',
                                        properties: {
                                            id: { type: 'string' },
                                            createdAt: {
                                                type: 'string',
                                                format: 'date-time',
                                            },
                                            updatedAt: {
                                                type: 'string',
                                                format: 'date-time',
                                            },
                                        },
                                        required: ['id', 'createdAt', 'updatedAt'],
                                    },
                                ],
                            },
                        },
                        required: ['message', 'doc'],
                    },
                },
            },
        },
        _a[componentName('responses', singular, { suffix: 'NotFound' })] = {
            description: "".concat(singular, " not found"),
        },
        _a[componentName('responses', singular, { suffix: 'List' })] = {
            description: "List of ".concat(plural),
            content: {
                'text/json': {
                    schema: {
                        type: 'object',
                        properties: {
                            docs: {
                                type: 'array',
                                items: composeRef('schemas', singular),
                            },
                            totalDocs: { type: 'integer' },
                            limit: { type: 'integer' },
                            totalPages: { type: 'integer' },
                            page: { type: 'integer' },
                            pagingCounter: { type: 'integer' },
                            hasPrevPage: { type: 'boolean' },
                            hasNextPage: { type: 'boolean' },
                            prevPage: { type: ['integer', 'null'] },
                            nextPage: { type: ['integer', 'null'] },
                        },
                        required: [
                            'docs',
                            'totalDocs',
                            'limit',
                            'totalPages',
                            'page',
                            'pagingCounter',
                            'hasPrevPage',
                            'hasNextPage',
                            'prevPage',
                            'nextPage',
                        ],
                    },
                },
            },
        },
        _a;
};
var generateCollectionOperations = function (collection) {
    var _a;
    var slug = collection.config.slug;
    var _b = collectionName(collection), singular = _b.singular, plural = _b.plural;
    var tags = [plural];
    var singleObjectResponses = {
        200: composeRef('responses', singular),
        404: composeRef('responses', singular, { suffix: 'NotFound' }),
    };
    return _a = {},
        _a["/api/".concat(slug)] = {
            get: {
                summary: "Retrieve a list of ".concat(plural),
                tags: tags,
                parameters: [
                    { in: 'query', name: 'page', schema: { type: 'number' } },
                    { in: 'query', name: 'limit', schema: { type: 'number' } },
                    {
                        in: 'query',
                        name: 'sort',
                        schema: {
                            type: 'string',
                            enum: collection.config.fields.flatMap(function (field) {
                                if (field.type === 'number' ||
                                    field.type === 'text' ||
                                    field.type === 'email' ||
                                    field.type === 'date') {
                                    return [field.name, "-".concat(field.name)];
                                }
                                return [];
                            }),
                        },
                    },
                    {
                        in: 'query',
                        name: 'where',
                        style: 'deepObject',
                        schema: {
                            allOf: [
                                { type: 'object' },
                                {
                                    anyOf: [
                                        composeRef('schemas', singular, { suffix: 'QueryOperations' }),
                                        composeRef('schemas', singular, { suffix: 'QueryOperationsAnd' }),
                                        composeRef('schemas', singular, { suffix: 'QueryOperationsOr' }),
                                    ],
                                },
                            ],
                        },
                    },
                ],
                responses: {
                    200: composeRef('responses', singular, { suffix: 'List' }),
                },
            },
            post: {
                summary: "Create a new ".concat(singular),
                tags: tags,
                requestBody: composeRef('requestBodies', singular),
                responses: {
                    201: composeRef('responses', singular, { prefix: 'New' }),
                },
            },
        },
        _a["/api/".concat(slug, "/{id}")] = {
            parameters: [
                {
                    in: 'path',
                    name: 'id',
                    description: "ID of the ".concat(singular),
                    required: true,
                    schema: {
                        type: 'string',
                    },
                },
            ],
            get: {
                summary: "Find a ".concat(singular, " by ID"),
                tags: tags,
                responses: singleObjectResponses,
            },
            patch: {
                summary: "Update a ".concat(singular),
                tags: tags,
                responses: singleObjectResponses,
            },
            delete: {
                summary: "Delete a ".concat(singular),
                tags: tags,
                responses: singleObjectResponses,
            },
        },
        _a;
};
var generateGlobalResponse = function (global) {
    var name = globalName(global);
    return {
        description: name,
        content: {
            'text/json': {
                schema: composeRef('schemas', name, { suffix: 'Read' }),
            },
        },
    };
};
var generateGlobalRequestBody = function (global) {
    var name = globalName(global);
    return {
        description: name,
        content: {
            'text/json': {
                schema: composeRef('schemas', name, { suffix: 'Write' }),
            },
        },
    };
};
var generateGlobalSchemas = function (config, global) {
    var _a;
    var schema = (0, utilities_1.entityToJSONSchema)(config, global);
    return _a = {},
        _a[componentName('schemas', globalName(global))] = __assign(__assign({}, schema), { title: globalName(global) }),
        _a[componentName('schemas', globalName(global), { suffix: 'Read' })] = {
            title: "".concat(globalName(global), " (if present)"),
            oneOf: [schema, { type: 'object', properties: {} }],
        },
        _a[componentName('schemas', globalName(global), { suffix: 'Write' })] = __assign(__assign({}, requestBodySchema(global.fields, schema)), { title: "".concat(globalName(global), " (writable fields)") }),
        _a;
};
var generateGlobalOperations = function (global) {
    var _a;
    var slug = global.slug;
    var singular = globalName(global);
    var tags = [singular];
    return _a = {},
        _a["/api/globals/".concat(slug)] = {
            get: {
                summary: "Get the ".concat(singular),
                tags: tags,
                responses: { 200: composeRef('responses', singular) },
            },
            post: {
                summary: "Update the ".concat(singular),
                tags: tags,
                requestBody: composeRef('requestBodies', singular),
                responses: { 200: composeRef('responses', singular) },
            },
        },
        _a;
};
var generateComponents = function (req) {
    var schemas = {};
    for (var _i = 0, _a = Object.values(req.payload.collections); _i < _a.length; _i++) {
        var collection = _a[_i];
        var singular = collectionName(collection).singular;
        schemas[componentName('schemas', singular)] = generateSchemaObject(req.payload.config, collection);
    }
    for (var _b = 0, _c = Object.values(req.payload.collections); _b < _c.length; _b++) {
        var collection = _c[_b];
        Object.assign(schemas, generateQueryOperationSchemas(collection));
    }
    for (var _d = 0, _e = req.payload.globals.config; _d < _e.length; _d++) {
        var global_2 = _e[_d];
        Object.assign(schemas, generateGlobalSchemas(req.payload.config, global_2));
    }
    var requestBodies = {};
    for (var _f = 0, _g = Object.values(req.payload.collections); _f < _g.length; _f++) {
        var collection = _g[_f];
        var singular = collectionName(collection).singular;
        requestBodies[componentName('requestBodies', singular)] = generateRequestBodySchema(req.payload.config, collection);
    }
    for (var _h = 0, _j = req.payload.globals.config; _h < _j.length; _h++) {
        var global_3 = _j[_h];
        requestBodies[componentName('requestBodies', globalName(global_3))] =
            generateGlobalRequestBody(global_3);
    }
    var responses = Object.assign.apply(Object, __spreadArray(__spreadArray([{}], Object.values(req.payload.collections).map(generateCollectionResponses), false), req.payload.globals.config.map(function (global) {
        var _a;
        return (_a = {},
            _a[componentName('responses', globalName(global))] = generateGlobalResponse(global),
            _a);
    }), false));
    return { schemas: schemas, requestBodies: requestBodies, responses: responses };
};
var generateV30Spec = function (req, metadata) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, schemas, requestBodies, responses, spec;
    var _b, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = generateComponents(req), schemas = _a.schemas, requestBodies = _a.requestBodies, responses = _a.responses;
                _b = {
                    openapi: '3.0.3',
                    info: metadata,
                    servers: [{ url: "".concat(req.protocol, "://").concat(req.header('host')) }],
                    paths: Object.assign.apply(Object, __spreadArray(__spreadArray([{}], Object.values(req.payload.collections).map(generateCollectionOperations), false), req.payload.globals.config.map(generateGlobalOperations), false))
                };
                _c = {};
                return [4 /*yield*/, mapValuesAsync(json_schema_to_openapi_schema_1.default, schemas)];
            case 1:
                _c.schemas = _d.sent();
                return [4 /*yield*/, mapValuesAsync(function (requestBody) { return __awaiter(void 0, void 0, void 0, function () {
                        var _a;
                        var _b;
                        return __generator(this, function (_c) {
                            switch (_c.label) {
                                case 0:
                                    _a = [__assign({}, requestBody)];
                                    _b = {};
                                    return [4 /*yield*/, mapValuesAsync(function (contentItem) { return __awaiter(void 0, void 0, void 0, function () {
                                            var _a, _b;
                                            var _c;
                                            return __generator(this, function (_d) {
                                                switch (_d.label) {
                                                    case 0:
                                                        _a = [__assign({}, contentItem)];
                                                        _c = {};
                                                        if (!contentItem.schema) return [3 /*break*/, 2];
                                                        return [4 /*yield*/, (0, json_schema_to_openapi_schema_1.default)(contentItem.schema)];
                                                    case 1:
                                                        _b = _d.sent();
                                                        return [3 /*break*/, 3];
                                                    case 2:
                                                        _b = undefined;
                                                        _d.label = 3;
                                                    case 3: return [2 /*return*/, (__assign.apply(void 0, _a.concat([(_c.schema = _b, _c)])))];
                                                }
                                            });
                                        }); }, requestBody.content)];
                                case 1: return [2 /*return*/, (__assign.apply(void 0, _a.concat([(_b.content = (_c.sent()), _b)])))];
                            }
                        });
                    }); }, requestBodies)];
            case 2:
                _c.requestBodies = _d.sent();
                return [4 /*yield*/, mapValuesAsync(function (response) { return __awaiter(void 0, void 0, void 0, function () {
                        var _a, _b;
                        var _c;
                        return __generator(this, function (_d) {
                            switch (_d.label) {
                                case 0:
                                    _a = [__assign({}, response)];
                                    _c = {};
                                    if (!(response.content !== undefined)) return [3 /*break*/, 2];
                                    return [4 /*yield*/, mapValuesAsync(function (contentItem) { return __awaiter(void 0, void 0, void 0, function () {
                                            var _a, _b;
                                            var _c;
                                            return __generator(this, function (_d) {
                                                switch (_d.label) {
                                                    case 0:
                                                        _a = [__assign({}, contentItem)];
                                                        _c = {};
                                                        if (!contentItem.schema) return [3 /*break*/, 2];
                                                        return [4 /*yield*/, (0, json_schema_to_openapi_schema_1.default)(contentItem.schema)];
                                                    case 1:
                                                        _b = _d.sent();
                                                        return [3 /*break*/, 3];
                                                    case 2:
                                                        _b = undefined;
                                                        _d.label = 3;
                                                    case 3: return [2 /*return*/, (__assign.apply(void 0, _a.concat([(_c.schema = _b, _c)])))];
                                                }
                                            });
                                        }); }, response.content)];
                                case 1:
                                    _b = (_d.sent());
                                    return [3 /*break*/, 3];
                                case 2:
                                    _b = {};
                                    _d.label = 3;
                                case 3: return [2 /*return*/, __assign.apply(void 0, _a.concat([(_c.content = _b, _c)]))];
                            }
                        });
                    }); }, responses)];
            case 3:
                spec = (_b.components = (_c.responses = _d.sent(),
                    _c),
                    _b);
                adjustRefTargets(req, spec);
                return [2 /*return*/, spec];
        }
    });
}); };
exports.generateV30Spec = generateV30Spec;
var generateV31Spec = function (req, metadata) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, schemas, requestBodies, responses, spec;
    return __generator(this, function (_b) {
        _a = generateComponents(req), schemas = _a.schemas, requestBodies = _a.requestBodies, responses = _a.responses;
        spec = {
            openapi: '3.1.0',
            info: metadata,
            servers: [{ url: "".concat(req.protocol, "://").concat(req.header('host')) }],
            paths: Object.assign.apply(Object, __spreadArray(__spreadArray([{}], Object.values(req.payload.collections).map(generateCollectionOperations), false), req.payload.globals.config.map(generateGlobalOperations), false)),
            components: {
                schemas: schemas,
                requestBodies: requestBodies,
                responses: responses,
            },
        };
        adjustRefTargets(req, spec);
        return [2 /*return*/, spec];
    });
}); };
exports.generateV31Spec = generateV31Spec;
//# sourceMappingURL=openapiSpec.js.map